"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.extract = void 0;
var cli_1 = require("@formatjs/cli");
var fast_glob_1 = __importDefault(require("fast-glob"));
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var extractMessages = function (glob) { return __awaiter(void 0, void 0, void 0, function () {
    var files, formattedMessages, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                files = fast_glob_1["default"].sync(glob);
                _b = (_a = JSON).parse;
                return [4 /*yield*/, (0, cli_1.extract)(files, {})];
            case 1:
                formattedMessages = _b.apply(_a, [_c.sent()]);
                return [2 /*return*/, Object.fromEntries(Object.entries(formattedMessages).map(function (_a) {
                        var k = _a[0], v = _a[1];
                        return [k, v.defaultMessage];
                    }))];
        }
    });
}); };
var readLangFile = function (locale, outDir) { return __awaiter(void 0, void 0, void 0, function () {
    var filePath, _a, _b, err_1;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                filePath = path_1["default"].resolve(outDir, "".concat(locale, ".json"));
                _c.label = 1;
            case 1:
                _c.trys.push([1, 3, , 4]);
                _b = (_a = JSON).parse;
                return [4 /*yield*/, fs_1["default"].promises.readFile(filePath, { encoding: 'utf-8' })];
            case 2: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
            case 3:
                err_1 = _c.sent();
                if (err_1.code === 'ENOENT')
                    return [2 /*return*/, {}];
                throw err_1;
            case 4: return [2 /*return*/];
        }
    });
}); };
var writeLang = function (locale, outDir, messages) { return __awaiter(void 0, void 0, void 0, function () {
    var filePath;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                filePath = path_1["default"].resolve(outDir, "".concat(locale, ".json"));
                return [4 /*yield*/, fs_1["default"].promises.mkdir(path_1["default"].dirname(filePath), { recursive: true })];
            case 1:
                _a.sent();
                return [4 /*yield*/, fs_1["default"].promises.writeFile(filePath, JSON.stringify(messages, undefined, 2))];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var updateLang = function (messages, keys) {
    var newMessages = {};
    keys.forEach(function (k) { return (newMessages[k] = messages[k] || ''); });
    return newMessages;
};
var extract = function (_a) {
    var glob = _a.glob, outDir = _a.outDir, locales = _a.locales, defaultLocale = _a.defaultLocale;
    return __awaiter(void 0, void 0, void 0, function () {
        var extractedMessages, keys, langs, newLangs;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!locales.includes(defaultLocale))
                        throw new Error("defaultLocale \"".concat(defaultLocale, "\" not found in locales array [").concat(locales.join(', '), "]"));
                    console.log('Extracting messages...');
                    return [4 /*yield*/, extractMessages(glob)];
                case 1:
                    extractedMessages = _b.sent();
                    keys = Object.keys(extractedMessages);
                    console.log(keys.length ? "".concat(keys.length, " message").concat(keys.length > 1 ? 's' : '', " found") : 'No message found');
                    return [4 /*yield*/, Promise.all(locales.map(function (l) { return readLangFile(l, outDir); }))];
                case 2:
                    langs = _b.sent();
                    newLangs = locales.map(function (l, index) {
                        if (l === defaultLocale)
                            return extractedMessages;
                        return updateLang(langs[index], keys);
                    });
                    return [4 /*yield*/, Promise.all(locales.map(function (l, index) {
                            var messages = newLangs[index];
                            var missingTranslationsCount = Object.values(messages).filter(function (v) { return v === ''; }).length;
                            if (missingTranslationsCount)
                                console.log("[INFO] ".concat(missingTranslationsCount, " missing translation").concat(missingTranslationsCount > 1 ? 's' : '', " for locale '").concat(l, "'"));
                            return writeLang(l, outDir, messages);
                        }))];
                case 3:
                    _b.sent();
                    console.log('Done');
                    return [2 /*return*/];
            }
        });
    });
};
exports.extract = extract;
